#--------------------------------------------------------
#	Ɛ_X́~vC
#	2008/01/02 KAZOON
#--------------------------------------------------------
require 'vr/vruby'
require 'vr/vrcontrol'
require 'vr/vrlayout'
require 'witch_sub'

#{̃tH[łB
module Main
	include VRGridLayoutManager
	include VRMenuUseable

	@@editable = false
	@@playing = false
	@@battle_data = nil
	@@selected_stone = nil
	@@opponent = 'm'
	@@matta = false
	@@level = nil

	def construct
		self.caption = 'Ɛ_X́~'

		setMenu(newMenu.set([
			['t@C(&F)', [
				['[h(&L)', 'load'],
				['Z[u(&S)', 'save'],
				['ҏW֎~(&B)', 'ban', VRMenuItem::CHECKED],
				VRMenu::SEPARATOR,
				['I(&X)', 'exit']
			]],
			['Q[(&G)', [
				['Jn(&S)', 'start'],
				VRMenu::SEPARATOR,
				['ΐ푊(&O)', [
					['l(&M)', 'man', VRMenuItem::CHECKED],
					['ViI(&S)', 'scenario'],
					['\Gl(&C)', [
						['O(&0)', 'char0'],
						['mGnh(&1)', 'char1'],
						['ؑTC_[(&2)', 'char2'],
						['lo(&3)', 'char3'],
						['mJCi(&4)', 'char4'],
						['҃\}NeB(&5)', 'char5']
					]]
				]],
				['҂(&M)', 'matta']
			]]
		]))
		setDimension(12, 6)
		addControl(GlobalInfo, 'info', 'S̓Iȏpl', 0, 0, 12, 1)
		addControl(VRListbox, 'gote', '񃊃Xg', 0, 1, 5, 5)
		@gote.setListStrings(['~yHP20z'])
		addControl(BattleSheet, 'sheet', 'ΐV[g', 5, 1, 2, 5)
		addControl(VRListbox, 'sente', '񃊃Xg', 7, 1, 5, 5)
		@sente.setListStrings(['yHP20z'])
	end
	attr_reader :sheet, :sente, :gote

	def load_clicked
		current_directory = Dir.pwd
		filename = openFilenameDialog([['Ɛ_X́~t@C(*.kif)', '*.kif']])
		Dir.chdir(current_directory)
		unless filename.nil?
			@@battle_data = BattleData.new('m')
			@@battle_data.load(filename)
			@info.start.disable
			@info.back.disable
			if @@battle_data.kifu.size != 0
				@info.ahead.enable
				@info.last.enable
			end
			@info.text.caption = ''
			refresh_sheet()
			@sente.setListStrings(["yHP#{@@battle_data.sente_hp}z"])
			@gote.setListStrings(["~yHP#{@@battle_data.gote_hp}z"])
			@@selected_stone = nil
			@@playing = false
			GC.start
		end
	end

	def save_clicked
		if @@battle_data
			current_directory = Dir.pwd
			filename = saveFilenameDialog([['Ɛ_X́~t@C(*.kif)', '*.kif']])
			Dir.chdir(current_directory)
			unless filename.nil?
				filename << '.kif' if filename !~ /\.kif$/i
				File.open(filename, 'w'){ |file|
					file.puts(@@battle_data.opponent, @@battle_data.kifu.inspect)
				}
			end
		end
	end

	def ban_clicked
		@@editable = !(@ban.checked = !@ban.checked?)
	end

	def exit_clicked
		exit
	end

	#V[g̏̕Ԃ܂B
	def cell_caption(coord)
		case @@battle_data.sheet[coord[1]-1][coord[0]-1]
		when 0
			''
		when 1
			'~'
		when nil
			''
		end
	end
	#V[gĕ`悵܂B
	def refresh_sheet
		@sheet.c11.caption = cell_caption([1, 1])
		@sheet.c12.caption = cell_caption([1, 2])
		@sheet.c13.caption = cell_caption([1, 3])
		@sheet.c21.caption = cell_caption([2, 1])
		@sheet.c22.caption = cell_caption([2, 2])
		@sheet.c23.caption = cell_caption([2, 3])
		@sheet.c31.caption = cell_caption([3, 1])
		@sheet.c32.caption = cell_caption([3, 2])
		@sheet.c33.caption = cell_caption([3, 3])
	end

	#\vCɓGi߂܂ł̃EFCgV[gꎞIɓ܂B
	def sheet_disable
		@sheet.c11.disable
		@sheet.c12.disable
		@sheet.c13.disable
		@sheet.c21.disable
		@sheet.c22.disable
		@sheet.c23.disable
		@sheet.c31.disable
		@sheet.c32.disable
		@sheet.c33.disable
	end
	#ꎞ܂B
	def sheet_enable
		@sheet.c11.enable
		@sheet.c12.enable
		@sheet.c13.enable
		@sheet.c21.enable
		@sheet.c22.enable
		@sheet.c23.enable
		@sheet.c31.enable
		@sheet.c32.enable
		@sheet.c33.enable
	end
	#G̓s܂B
	def enemy_move
		begin
			sheet_disable
			sleep(0.4)
			te = @@battle_data.enemy.strategy[(@@battle_data.turn).div(2)]
			card = @@battle_data.sasu(te, true)
			refresh_sheet()
			@info.text.caption = "#{@@battle_data.turn}#{(@@battle_data.turn % 2 == 1) ? '' : '~'}"
			case te.size
			when 2
				@info.text.caption += "#{te[0]}#{te[1]}#{card ? 'u'+card+'v' : nil}"
			when 4
				@info.text.caption += "#{te[0]}#{te[1]}-#{te[2]}#{te[3]}#{card ? 'u'+card+'v' : nil}"
			end
			if card
				case @@battle_data.turn % 2
				when 1
					@sente.addString(card)
					@gote.deleteString(0)
					if @@battle_data.gote_hp <= 0
						@gote.addString(0, '~yHP0z')
						case @@battle_data.enemy.limit % 2
						when 1
							messageBox("Ȃ#{@@battle_data.enemy.name}ɏB", 'I', 0)
							@@level += 1 if @@level
						when 0
							messageBox("Ȃ#{@@battle_data.enemy.name}ɔsꂽB", 'I', 0)
						end
						@@playing = false
						@info.start.enable
						@info.back.enable
					else
						@gote.addString(0, "~yHP#{@@battle_data.gote_hp}z")
					end
				when 0
					@gote.addString(card)
					@sente.deleteString(0)
					if @@battle_data.sente_hp <= 0
						@sente.addString(0, 'yHP0z')
						case @@battle_data.enemy.limit % 2
						when 0
							messageBox("Ȃ#{@@battle_data.enemy.name}ɏB", 'I', 0)
							@@level += 1 if @@level
						when 1
							messageBox("Ȃ#{@@battle_data.enemy.name}ɔsꂽB", 'I', 0)
						end
						@@playing = false
						@info.start.enable
						@info.back.enable
					else
						@sente.addString(0, "yHP#{@@battle_data.sente_hp}z")
					end
				end
			end
			sheet_enable
		rescue
			messageBox($!.message, $!.title, 0)
		end
	end
	def start_clicked
		if @@opponent == 's'
			@@level = 1 if @@level > 5
			@@battle_data = BattleData.new(@@level.to_s)
		else
			@@battle_data = BattleData.new(@@opponent)
		end
		@info.start.disable
		@info.back.disable
		@info.ahead.disable
		@info.last.disable
		@info.text.caption = ''
		refresh_sheet()
		@sente.setListStrings(["yHP#{@@battle_data.sente_hp}z"])
		@gote.setListStrings(["~yHP#{@@battle_data.gote_hp}z"])
		@@selected_stone = nil
		@@playing = true
		if @@battle_data.enemy
			case @@battle_data.enemy.limit%2
			when 0
				messageBox("Ȃ:HP#{@@battle_data.gote_hp}, (~)\n#{@@battle_data.enemy.name}:HP#{@@battle_data.sente_hp}, ()\n^[:#{@@battle_data.enemy.limit}", @@battle_data.enemy.title, 0)
				enemy_move()
			when 1
				messageBox("Ȃ:HP#{@@battle_data.sente_hp}, ()\n#{@@battle_data.enemy.name}:HP#{@@battle_data.gote_hp}, (~)\n^[:#{@@battle_data.enemy.limit}", @@battle_data.enemy.title, 0)
			end
		end
		GC.start
	end

	#IĂG̃`FbNO܂B
	def opponent_discheck
		@man.checked = @scenario.checked = @char0.checked = @char1.checked = @char2.checked = @char3.checked = @char4.checked = @char5.checked = false
	end
	def man_clicked
		opponent_discheck()
		@man.checked = true
		@@opponent = 'm'
		@@level = nil
	end
	def scenario_clicked
		opponent_discheck()
		@scenario.checked = true
		@@opponent = 's'
		@@level = 1
	end
	def char0_clicked
		opponent_discheck()
		@char0.checked = true
		@@opponent = '0'
		@@level = nil
	end
	def char1_clicked
		opponent_discheck()
		@char1.checked = true
		@@opponent = '1'
		@@level = nil
	end
	def char2_clicked
		opponent_discheck()
		@char2.checked = true
		@@opponent = '2'
		@@level = nil
	end
	def char3_clicked
		opponent_discheck()
		@char3.checked = true
		@@opponent = '3'
		@@level = nil
	end
	def char4_clicked
		opponent_discheck()
		@char4.checked = true
		@@opponent = '4'
		@@level = nil
	end
	def char5_clicked
		opponent_discheck()
		@char5.checked = true
		@@opponent = '5'
		@@level = nil
	end

	def matta_clicked
		@@matta = @matta.checked = !@matta.checked?
		if @@matta && @@playing && @@battle_data.turn > 0
			@info.start.enable
			@info.back.enable
		end
		if !@@matta && @@playing
			@info.start.disable
			@info.back.disable
			@info.ahead.disable
			@info.last.disable
		end
	end

	#NbNCi߂ƂɌĂ΂郁\bhłB
	def check_and_do(coord)
		begin
			raise MyException, '΋ǂJnĂ܂B' unless @@playing || @@editable
			if @@battle_data.turn > 5 && !@@selected_stone
				raise MyIllegalError, 'ɂ͎̐΂܂B' if @@battle_data.sheet[coord[1]-1][coord[0]-1] != @@battle_data.turn % 2
				if @@battle_data.enemy && @@battle_data.turn < @@battle_data.enemy.limit - 1
					tsugi = @@battle_data.enemy.strategy[(@@battle_data.turn+1).div(2)][2, 2]
					if @@battle_data.sheet[tsugi[1]-1][tsugi[0]-1] && coord != tsugi
						raise MyIllegalError, "#{tsugi.inspect}͓GɎwꏊłB̐΂ǂȂ΂Ȃ܂B"
					end
				end
				@@selected_stone = coord
				return
			end
			te = (@@selected_stone ? @@selected_stone.dup.concat(coord) : coord)
			card = @@battle_data.sasu(te)
			@@selected_stone = nil
			if @@battle_data.turn == 1 && @@matta
				@info.start.enable
				@info.back.enable
			end
			@info.ahead.disable
			@info.last.disable
			refresh_sheet()
			@info.text.caption = "#{@@battle_data.turn}#{(@@battle_data.turn % 2 == 1) ? '' : '~'}"
			case te.size
			when 2
				@info.text.caption += "#{te[0]}#{te[1]}#{card ? 'u'+card+'v' : nil}"
			when 4
				@info.text.caption += "#{te[0]}#{te[1]}-#{te[2]}#{te[3]}#{card ? 'u'+card+'v' : nil}"
			end
			if card
				case @@battle_data.turn % 2
				when 1
					@sente.addString(card)
					@gote.deleteString(0)
					if @@battle_data.gote_hp <= 0
						@gote.addString(0, '~yHP0z')
						if @@battle_data.enemy
							case @@battle_data.enemy.limit % 2
							when 1
								messageBox("Ȃ#{@@battle_data.enemy.name}ɏB", 'I', 0)
								@@level += 1 if @@level
							when 0
								messageBox("Ȃ#{@@battle_data.enemy.name}ɔsꂽB", 'I', 0)
							end
						else
							messageBox('̏łB', 'I', 0)
						end
						@@playing = false
						@info.start.enable
						@info.back.enable
					else
						@gote.addString(0, "~yHP#{@@battle_data.gote_hp}z")
					end
				when 0
					@gote.addString(card)
					@sente.deleteString(0)
					if @@battle_data.sente_hp <= 0
						@sente.addString(0, 'yHP0z')
						if @@battle_data.enemy
							case @@battle_data.enemy.limit % 2
							when 0
								messageBox("Ȃ#{@@battle_data.enemy.name}ɏB", 'I', 0)
								@@level += 1 if @@level
							when 1
								messageBox("Ȃ#{@@battle_data.enemy.name}ɔsꂽB", 'I', 0)
							end
						else
							messageBox('̏łB', 'I', 0)
						end
						@@playing = false
						@info.start.enable
						@info.back.enable
					else
						@sente.addString(0, "yHP#{@@battle_data.sente_hp}z")
					end
				end
			end
			if @@battle_data.enemy && @@battle_data.turn >= @@battle_data.enemy.limit
				if @@battle_data.sente_hp * @@battle_data.gote_hp > 0
					messageBox("Ȃ#{@@battle_data.enemy.name}ɔsꂽB", '^CAbv', 0)
					@info.start.enable
					@info.back.enable
				end
				@@playing = false
				@info.start.enable
				@info.back.enable
			end
			enemy_move() if @@battle_data.enemy && @@playing
		rescue
			@@selected_stone = nil
			messageBox($!.message, $!.title, 0)
		end
	end
	def sheet_c11_clicked; check_and_do([1, 1]); end
	def sheet_c12_clicked; check_and_do([1, 2]); end
	def sheet_c13_clicked; check_and_do([1, 3]); end
	def sheet_c21_clicked; check_and_do([2, 1]); end
	def sheet_c22_clicked; check_and_do([2, 2]); end
	def sheet_c23_clicked; check_and_do([2, 3]); end
	def sheet_c31_clicked; check_and_do([3, 1]); end
	def sheet_c32_clicked; check_and_do([3, 2]); end
	def sheet_c33_clicked; check_and_do([3, 3]); end

	def info_start_clicked
		begin
			@@selected_stone = nil
			while @@battle_data.turn != 0
				@@battle_data.modoru
			end
			@info.start.disable
			@info.back.disable
			@info.ahead.enable
			@info.last.enable
			@info.text.caption = ''
			refresh_sheet()
			@sente.setListStrings(["yHP#{@@battle_data.sente_hp}z"])
			@gote.setListStrings(["~yHP#{@@battle_data.gote_hp}z"])
		rescue
			messageBox($!.message, $!.title, 0)
		end
	end
	def info_back_clicked
		begin
			@@selected_stone = nil
			card = @@battle_data.modoru
			if @@battle_data.turn == 0
				@info.start.disable
				@info.back.disable
				@info.text.caption = ''
			else
				@info.text.caption = "#{@@battle_data.turn}#{(@@battle_data.turn % 2 == 1) ? '' : '~'}"
				te = @@battle_data.kifu[@@battle_data.turn-1][0]
				last_card = (@@battle_data.kifu[@@battle_data.turn-1][1])
				case te.size
				when 2
					@info.text.caption += "#{te[0]}#{te[1]}#{last_card}"
				when 4
					@info.text.caption += "#{te[0]}#{te[1]}-#{te[2]}#{te[3]}#{last_card}"
				end
			end
			@info.ahead.enable
			@info.last.enable
			refresh_sheet()
			if card
				case @@battle_data.turn % 2
				when 0
					@sente.deleteString(@sente.countStrings-1)
					@gote.deleteString(0)
					@gote.addString(0, "~yHP#{@@battle_data.gote_hp}z")
				when 1
					@gote.deleteString(@gote.countStrings-1)
					@sente.deleteString(0)
					@sente.addString(0, "yHP#{@@battle_data.sente_hp}z")
				end
			end
		rescue
			messageBox($!.message, $!.title, 0)
		end
	end
	def info_ahead_clicked
		begin
			@@selected_stone = nil
			card = @@battle_data.susumu
			@info.start.enable
			@info.back.enable
			if @@battle_data.turn == @@battle_data.kifu.size
				@info.ahead.disable
				@info.last.disable
			end
			@info.text.caption = "#{@@battle_data.turn}#{(@@battle_data.turn % 2 == 1) ? '' : '~'}"
			te = @@battle_data.kifu[@@battle_data.turn-1][0]
			case te.size
			when 2
				@info.text.caption += "#{te[0]}#{te[1]}#{card ? 'u'+card+'v' : nil}"
			when 4
				@info.text.caption += "#{te[0]}#{te[1]}-#{te[2]}#{te[3]}#{card ? 'u'+card+'v' : nil}"
			end
			refresh_sheet()
			if card
				case @@battle_data.turn % 2
				when 1
					@sente.addString(card)
					@gote.deleteString(0)
					if @@battle_data.gote_hp <= 0
						@gote.addString(0, '~yHP0z')
					else
						@gote.addString(0, "~yHP#{@@battle_data.gote_hp}z")
					end
				when 0
					@gote.addString(card)
					@sente.deleteString(0)
					if @@battle_data.sente_hp <= 0
						@sente.addString(0, 'yHP0z')
					else
						@sente.addString(0, "yHP#{@@battle_data.sente_hp}z")
					end
				end
			end
		rescue
			messageBox($!.message, $!.title, 0)
		end
	end
	def info_last_clicked
		begin
			@@selected_stone = nil
			while @@battle_data.turn < @@battle_data.kifu.size
				card = @@battle_data.susumu
				if card
					case @@battle_data.turn % 2
					when 1
						@sente.addString(card)
						@gote.deleteString(0)
						if @@battle_data.gote_hp <= 0
							@gote.addString(0, '~yHP0z')
						else
							@gote.addString(0, "~yHP#{@@battle_data.gote_hp}z")
						end
					when 0
						@gote.addString(card)
						@sente.deleteString(0)
						if @@battle_data.sente_hp <= 0
							@sente.addString(0, 'yHP0z')
						else
							@sente.addString(0, "yHP#{@@battle_data.sente_hp}z")
						end
					end
				end
			end
			@info.start.enable
			@info.back.enable
			@info.ahead.disable
			@info.last.disable
			@info.text.caption = "#{@@battle_data.turn}#{(@@battle_data.turn % 2 == 1) ? '' : '~'}"
			te = @@battle_data.kifu[-1][0]
			case te.size
			when 2
				@info.text.caption += "#{te[0]}#{te[1]}#{card ? 'u'+card+'v' : nil}"
			when 4
				@info.text.caption += "#{te[0]}#{te[1]}-#{te[2]}#{te[3]}#{card ? 'u'+card+'v' : nil}"
			end
			refresh_sheet()
		rescue
			messageBox($!.message, $!.title, 0)
		end
	end
end

#ΐV[głB̃{^Ȃ܂B
class BattleSheet < VRPanel
	include VRGridLayoutManager
	include VRStdControlContainer

	def construct
		setDimension(3, 3)
		addControl(VRButton, 'c11', '', 0, 0, 1, 1)
		addControl(VRButton, 'c12', '', 0, 1, 1, 1)
		addControl(VRButton, 'c13', '', 0, 2, 1, 1)
		addControl(VRButton, 'c21', '', 1, 0, 1, 1)
		addControl(VRButton, 'c22', '', 1, 1, 1, 1)
		addControl(VRButton, 'c23', '', 1, 2, 1, 1)
		addControl(VRButton, 'c31', '', 2, 0, 1, 1)
		addControl(VRButton, 'c32', '', 2, 1, 1, 1)
		addControl(VRButton, 'c33', '', 2, 2, 1, 1)
		send_parent('c11', 'clicked')
		send_parent('c12', 'clicked')
		send_parent('c13', 'clicked')
		send_parent('c21', 'clicked')
		send_parent('c22', 'clicked')
		send_parent('c23', 'clicked')
		send_parent('c31', 'clicked')
		send_parent('c32', 'clicked')
		send_parent('c33', 'clicked')
	end
	attr_reader :c11, :c12, :c13, :c21, :c22, :c23, :c31, :c32, :c33
end

#S̓IȏplłB
class GlobalInfo < VRPanel
	include VRGridLayoutManager
	include VRStdControlContainer

	def construct
		setDimension(24, 1)
		addControl(VRButton, 'start', 'n', 0, 0, 1, 1)
		@start.disable
		addControl(VRButton, 'back', '', 1, 0, 1, 1)
		@back.disable
		addControl(VRButton, 'ahead', 'i', 2, 0, 1, 1)
		@ahead.disable
		addControl(VRButton, 'last', 'I', 3, 0, 1, 1)
		@last.disable
		addControl(VRStatic, 'text', '', 4, 0, 20, 1)
		send_parent('start', 'clicked')
		send_parent('back', 'clicked')
		send_parent('ahead', 'clicked')
		send_parent('last', 'clicked')
	end
	attr_reader :start, :back, :ahead, :last, :text
end

VRLocalScreen.showForm(Main, 100, 100, 580, 170)
VRLocalScreen.messageloop
